<html>
<!--
	$Header: /home/george/lab/aukhtml/spanish/RCS/imagelist.php,v 1.3 2018/06/28 17:48:01 root Exp $
	$Log: imagelist.php,v $
	Revision 1.3  2018/06/28 17:48:01  root
	Fixed errors in Metadata Display

	Revision 1.2  2018/06/27 17:41:56  root
	Completed full Spanish translation

	Revision 1.1  2018/05/15 22:26:26  root
	Initial revision
-->
<head>
<meta http-equiv="Cache-Control" content="no-store">
<meta http-equiv="PRAGMA" content="no-store">
</head>
<body bgcolor="#000000" text="#FFFFFF">

<style>
a:link, a:visited {
background-color: #303030;
color: white;
text-align: center;
padding: 1px 8px;
text-decoration: none;
}
</style>
				
<?php
// function to find the end of the string.
function str_from_mem(&$value)
{
  $i = strpos($value, "\0");
  if ($i === false)
  {
	  return $value;
  }
  $result =  substr($value, 0, $i);
  return $result;
}

// Ask the camera to give us a list files to choose from:	
// the list will be placed in the large shared memory buffer.
// the command is sent in the small command buffer.

	// control variables
	$camcmdkey = 0x5551;
	$retry = 1000;
	$listkey = 0x5553;
	$loopcount = 0;
	$datasize = 0x200000; // 2 MB buffer
	$inum = 1;
	/* do delete image before loading the list */
	if(isset($_POST['delete'])) // delete request before file list
	{
		$inum = $_POST['imglist'];
		$cmdId = shmop_open($camcmdkey, "w", 0, 0);
		if($cmdId == 0) die ("did not open shared memory");
		$cmdstring = sprintf("#d%d\0", $inum);
		shmop_write($cmdId, $cmdstring, 0);
		usleep(10000); // give camera some time to get the command 
		for($retry = 5; $retry > 0; $retry--)
		{
			usleep(30000); // give camera some time to get the command 
			$ready = shmop_read($cmdId, 0, 1);
			if ($ready == '@') // wait for ack.
				break;
		}
		shmop_close ($cmdId);
	}
	// review the4 list in case it has changed
	$cmdId = shmop_open($camcmdkey, "w", 0, 0);
	$cmdstring = sprintf("#I  \n");
	shmop_write($cmdId, $cmdstring, 0);
	shmop_close ($cmdId);
	$listId = shmop_open($listkey, "w", 0, 0);
	if($listId == 0) die ("did not open shared memory");

	// wait for the camera to get a buffer ready
	for($retry = 5; $retry > 0; $retry--)
	{
		usleep(100000); // give camera some time to prepare list
		$ready = shmop_read($listId, 0, 1);
		if ($ready == '@')
			break;
	}

	$rawmem = shmop_read($listId, 1, $datasize);
	shmop_write($listId, "@", 0); 
	shmop_close($ListId);
	$rawlist = str_from_mem($rawmem);

	$filename = explode("\n",$rawlist);
	$numfiles = count($filename);

	$cmdId = shmop_open($camcmdkey, "w", 0, 0);
	if($cmdId == 0) die ("No se pudo abrir la memoria compartida.");

	// if the display or layer button was submitted, order the necessary preview
	if(($filename[0] != 'VACÍO') && (isset($_POST['display']) ||
		isset($_POST['planetoview']) || isset($_POST['indextoview']) ||
		isset($_POST['back']) || isset($_POST['fwd']) || isset($_POST['imglist']) ))
	{
		// load the requested image
		$cmdId = shmop_open($camcmdkey, "w", 0, 0);
		if($cmdId == 0) die ("No se pudo abrir la memoria compartida.");
		$layer = $_POST['planetoview'];
		$xlayer = $_POST['indextoview'];
		$inum = $_POST['imglist'];

		// set the image number ased on forward / back posts.
		if(isset($_POST['back']))
		{
			$inum = $inum - 1;
			if($inum < 1)
				$inum = $numfiles - 1;
		}
		if(isset($_POST['fwd']))
		{
			$inum = $inum + 1;
			if($inum >= $numfiles)
				$inum = 1;
		}
		if(isset($_POST['indextoview']) || isset($_POST['display']) ||
			isset($_POST['back']) || isset($_POST['fwd']) || isset($_POST['imglist']) )
		{
			if($xlayer == 0)
			{
				$cmdstring = sprintf("#P%d %d\0", $inum, $layer);
			}
			else
			{
				$cmdstring = sprintf("#x%d %d\0", $inum, ($xlayer - 1));
			}
			unlink("/var/www/html/image/pview.png"); // get rid of old preview

			shmop_write($cmdId, $cmdstring, 0);
			$sleeptime =100000;
			for($retry = 100; $retry > 0; $retry--)
			{
				usleep($sleeptime); // give camera some time to get the command 
				$ready = shmop_read($cmdId, 0, 1);
				if ($ready != "#")
					break;
			}
			/* allow some time for auk to prepare preview */
			if($xlayer > 0)
				sleep(3); 
		}
		shmop_close ($cmdId);
	}

// get the band ID strings to add to the slave/master labels
	$activename = "VACÍO";
	$extractions = array("View: Jpeg Preview Data","DESACTIVADO","DESACTIVADO","DESACTIVADO","DESACTIVADO",
		"DESACTIVADO","DESACTIVADO","DESACTIVADO","DESACTIVADO");
	$indexcount = 1;

	// set indices.txt file to read for availabe extraction info.
	$file = '/home/tetracam/TTCAUK/indices.txt';
	$data = file($file) or die('¡No se pudo leer el archivo de extracción de índice!');
	foreach ($data as $line)
	{
		if(!strncmp($line, "DESACTIVADO", 3))
			continue;
		if(!strncmp($line, "GEOK-SAVI", 9))
			continue;
		else
			$extractions[$indexcount] = $line;

		$indexcount++;
	}

	echo '<form name="dirform" style="display:inline" align="middle" method = "post" action="">';
	echo '<select name="imglist" style="width:200px; height:40px; margin-left:10;"onchange="dirform.submit();">';
		foreach ($filename as $thisname)
		{
			$loopcount++;
			if($inum == $loopcount)
				{
				echo '<option value="'.$loopcount.'" selected>'.$thisname;
				$activename = $thisname;
				}
			else
				echo '<option value="'.$loopcount.'">'.$thisname;
			echo '</option>';
		}
	echo '</select>';
?>

<input type="submit" style="width:120px; height:40px; margin:0 auto;" action="" value="Actualizar la lista" name='refresh'/>
<input type="submit" style="width:120px; height:40px; margin:0 auto;" action="" value="Mostrar la imagen" name='display'/>
<input type="submit" style="width:120px; height:40px; margin:0 auto;" action="" value="Borrar la imagen" name='delete'/>
</form>
<p style="margin-left:50px;">
Actualice la lista para asegurarse de que se agreguen los archivos recientes. <br>
El archivo seleccionado se puede mostrar debajo o eliminar.
</p>


<?php
$camcmdkey = 0x5551;
$imgpath = "../tetracam/TTCAUK/AUKJPGS/";
$cmdId = shmop_open($camcmdkey, "w", 0, 0);
if($cmdId == 0) die ("La memoria compartida no se pudo abrir");

    echo '<form name="picrev" style="display:inline;" method = "post" action="">';
	echo '<input type="submit" style="width:100px; height:40px; margin-left: 70px;" name="fwd" value=">>"/>';
	echo '<input type="submit" style="width:100px; height:40px; margin:2;" name="back" value="<<"/>';
	echo '<input type="hidden" name="imglist" value="'.$inum.'"/>';
	echo '<input type="hidden" name="file1" value="'.$inum.'"/>';
	echo '<input type="hidden" name="mlayer" value="'.$layer.'"/>';
	echo '<input type="hidden" name="file2" value="'.$activename.'"/>';
	echo '</form>';

    echo '<form name="metad" style="display:inline;" method="post" action="mdata.php">';
	echo '<input type="hidden" name="file1" value="'.$inum.'"/>';
	echo '<input type="hidden" name="mlayer" value="'.$layer.'"/>';
	echo '<input type="hidden" name="file2" value="'.$activename.'"/>';
	echo '<input type="submit" name="file4" style="width:100px; height:40px; margin:0 auto;" value="Metadatos"/>';
	echo '</form>';
							
	echo '<a href="'.$imgpath.$activename.'" download>Descargar imagen </a>';

// if raw band data is refreshed
$ixon = 0;
define(BGPROC, 284);
define(EXTRACTION, 1);
$fileS = '/home/tetracam/TTCAUK/settings.txt';
$dataS = file($fileS);
foreach ($dataS as $lineS)
{
	$tag = 0;
	$value = 0;
	sscanf($lineS, "%d %d", $tag, $value);
	if(($tag == BGPROC) && ($value >= EXTRACTION))
		$ixon = 1;
}

if(($filename[0] != 'VACÍO') && (isset($_POST['display']) || isset($_POST['planetoview']) ||
	(isset($_POST['imglist']) && !isset($_POST['indextoview'])) ))
{
		echo '<img src="../image/pview.jpg" style="margin-left:120; margin-right:auto;;" /><br>';
}
else if(isset($_POST['indextoview']) && ($_POST['indextoview'] == 0))
{
		echo '<img src="../image/pview.jpg" style="margin-left:120; margin-right:auto;;" /><br>';
}
// if an extraction is requested and settings say we are doing them, try to show it.
else if(($filename[0] != 'VACÍO') && isset($_POST['indextoview']))
		echo '<img src="../image/pview.png" style="margin-left:120; margin-right:auto;;" />';
else
{
	echo '<img src="../image/auk.png" style="margin-left:120; margin-right:auto;" />';
}
    echo '<form name="ixload" style="display:inline;" method = "post" action="">';
	echo '<input type="hidden" name="imglist" value="'.$inum.'"/>';
	if($ixon)
	{
	echo '<select name="indextoview"  id="index" style="width:340px; height:40px; margin-left:116px" onchange="ixload.submit();">';
		for($loopcount = 0; $loopcount < $indexcount; $loopcount++)
		{
				// Use raw bands first
				if($loopcount == 0)
					{
					echo '<option value="'.$loopcount.'"';
					if($loopcount == $_POST['indextoview'] ) echo ' selected';
					echo '>'.$extractions[$loopcount];
					}
				//slaves
				else
					{
					echo '<option value="'.$loopcount.'"';
					if($loopcount == $_POST['indextoview'] ) echo ' selected';
					echo '>'.$loopcount.' '.$extractions[$loopcount];
					}
				echo ' </option>';
		}
	echo '</select>';
	}
	echo '<br></form>';
	// clean up old messages.
	unset($_POST['display']);
	unset($_POST['layer']);
	unset($_POST['planetoview']);
	unset($_POST['refresh']);
	unset($_POST['fwd']);
	unset($_POST['indextoview']);
?>


</body>
</html>
